# -*- coding: utf-8 -*-
import sys
from pathlib import Path
from runpy import run_module, run_path
from subprocess import run

from activate_zipapps import activate


def activate_envs():
    activate()
    HANDLE_OTHER_ENVS_FLAG = "{HANDLE_OTHER_ENVS_FLAG}"
    try:
        index = sys.argv.index(HANDLE_OTHER_ENVS_FLAG)
        sys.argv.pop(index)
        env_paths = sys.argv.pop(index)
    except ValueError:
        env_paths = None
    if not env_paths:
        flag = HANDLE_OTHER_ENVS_FLAG + '='
        index_to_pop = None
        for index, value in enumerate(sys.argv):
            if value.startswith(flag):
                env_paths = value[len(flag):]
                index_to_pop = index
                break
        if index_to_pop is not None:
            sys.argv.pop(index_to_pop)
    if env_paths:
        for env_path in env_paths.split(','):
            activate(env_path)


def main():
    activate_envs()
    has_main = {has_main}
    if has_main:
        if {main_shell}:
            shell_args = [sys.executable, '-c', '{import_main};{run_main}']
            run(shell_args, shell={shell})
        else:
            {import_main}
            {run_main}
            return
    else:
        args = sys.argv
        if len(args) > 1:
            arg1 = args[1]
            if arg1 == '-c':
                source = args[2]
                sys.argv = [arg1] + args[3:]
                return exec(source)
            elif arg1 == '-':
                source = sys.stdin.read()
                sys.argv = [arg1] + args[2:]
                return exec(source)
            elif arg1 == '-m':
                sys.argv = args[2:]
                return run_module(args[2], run_name='__main__')
            else:
                if Path(arg1).is_file():
                    return run_path(arg1)
                else:
                    # python [-bBdEhiIOqsSuvVWx?]
                    shell_args = [sys.executable] + args[1:]
                    run(shell_args, shell={shell})
        else:
            import code
            code.interact()


if __name__ == "__main__":
    main()
